import { IPublicModelEngineConfig, IPublicModelPreference, IPublicTypeDisposable } from '@gant-lowcode/lowcode-types';
import { configSymbol } from '../symbols';
import { IEngineConfig } from '@gant-lowcode/lowcode-editor-core';
export declare class Config implements IPublicModelEngineConfig {
    private readonly [configSymbol];
    constructor(innerEngineConfig: IEngineConfig);
    has(key: string): boolean;
    get(key: string, defaultValue?: any): any;
    set(key: string, value: any): void;
    setConfig(config: {
        [key: string]: any;
    }): void;
    onceGot(key: string): Promise<any>;
    onGot(key: string, fn: (data: any) => void): IPublicTypeDisposable;
    getPreference(): IPublicModelPreference;
}
